<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_AUTH_BDDEXT")) return;
define("_ECRIRE_INC_AUTH_BDDEXT", "1");

require_once ('DB.php');

function spip_connect_bddext() {

	$dsn =$GLOBALS['bddext_type']."://".$GLOBALS['bddext_user'].":".$GLOBALS['bddext_password']."@".$GLOBALS['bddext_server']."/".$GLOBALS['bddext_base'];
		
	$bddext_link = @DB::connect($dsn);	
	
	if (DB::isError($bddext_link)) echo ("<font face='Verdana,Arial,Sans,sans-serif' size='4' color='#970038'><B>Problme de connexion BD</b></font><p>Attention&nbsp;: un probl&egrave;me (Base de donnes authentification externe) emp&ecirc;che l'acc&egrave;s &agrave; cette partie du site. Merci de votre compr&eacute;hension.<p><tt>".$bddext_link->getMessage())."</tt></p>";	
	
	$GLOBALS['bddext_link']=$bddext_link;
	return $GLOBALS['bddext_link'];
}

function salt() {
	// Cette fonction n'est pas utilise. Elle n'est mentionne qu' titre indicatif 	
	// pour pouvoir modifier la ligne 111 dans le cas du cryptage de mot de passe de type linux (crypt avec salt)
	$itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

	$salt="";
	for ($i=0;$i<8;$i++) $salt.=$itoa64[rand(0,64)];
	
	return($salt);
	
}	

function AjouteClause($requete,$clause,$operateur="AND") {
		if (!strstr($requete,"WHERE")) $requete.=" WHERE (".$clause.")";
		else $requete.=" $operateur (".$clause." )";
		return($requete);
	}

function AjouteClauseCond($requete,$clause,$operateur="OR") {
		if (($requete=="") AND ($clause!="")) $requete.=" AND ( (".$clause.")";
		if ($clause=="") return($requete." )");
		$requete.=" $operateur (".$clause." )";
		return($requete);
	}	
	
class Auth_bddext {
	var $nom, $bio, $email, $nom_site, $url_site, $login, $pass, $statut, $pgp;

	function init() {
		spip_log("entree dans auth_bddext");
		// Verifier la presence de bddext
		if (!$GLOBALS['bddext_present']) return false;
		return spip_connect_bddext();
	}

	function verifier_challenge_md5($login, $mdpass_actuel, $mdpass_futur) {
		return false;
	}

	function verifier($login, $pass) {
		
		global $bddext_link, $bddext_table, $bddext_table_jointure, $bddext_champ_jointure ;
		global $bddext_champs, $bddext_admin, $bddext_auteur, $bddext_type_pass;
		
		$cond_supp = '';
		
		// Securite...
		if (!$login || !$pass) return false;

		switch($bddext_type_pass) {
			case 1 : //mot de passe en clair
				$local_pass = $pass;
				break;
			case 2 : //mot de passe en md5 'simple'
				$local_pass = md5($pass);
				break;
			case 3 : //mot de passe en challenge_md5 (spip externe)
				$cond_supp = ', '.$bddext_champs['alea_actuel'].' AS alea'; //Select des alea.
				break;
			case 4 : //mot de passe type unix 
				// On ne fait rien pour le moment car on a besoin de rcuprer le salt
				break;
			case 0 : //pas de mot de passe, pas d'accs ;-)
			default :
				$local_pass = '';
		}
			

		$query = "SELECT ".$bddext_champs['login_ext']." AS login_ext, ".$bddext_champs['pass']." AS pass".$cond_supp." FROM ".$bddext_table;
		if ($bddext_table_jointure!="") {
			$query.=", $bddext_table_jointure";
			$query=AjouteClause($query,"$bddext_table.$bddext_champ_jointure=$bddext_table_jointure.$bddext_champ_jointure");
		}
	
		$query=AjouteClause($query,$bddext_champs['login_ext']."='".addslashes($login)."'");
		
		if ($bddext_champs['statut']!="") {			
			// Clauses supplmentaires pour dtecter le cas chants auteurs et administrateurs
			$cond_supp2="";
			foreach($bddext_admin as $cle => $val) $cond_supp2=AjouteClauseCond($cond_supp2,$bddext_champs['statut']."='$val'","OR");
			foreach($bddext_auteur as $cle => $val) $cond_supp2=AjouteClauseCond($cond_supp2,$bddext_champs['statut']."='$val'","OR");
			$cond_supp2=AjouteClauseCond($cond_supp2,"");
		}
		
		$query.=$cond_supp2;	
		
		$result = @$bddext_link->query($query);
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			if ($bddext_type_pass == 3) $local_pass = md5($row['alea'].$pass);
			if ($bddext_type_pass == 4) $local_pass=crypt($pass,'$1$'.substr($row['pass'],3,7)); // Modifier le substr pour tenir compte du nombre de caractres utiliss dans le salt
			
			if (addslashes($login) == $row['login_ext'] AND $local_pass == $row['pass']) {				
				$this->login = $login;
				return true;
			}
		}
		return false;
	}

	function lire() {
		
		global $bddext_link, $bddext_table, $bddext_table_jointure, $bddext_champ_jointure ;
		global $bddext_champs, $bddext_admin, $bddext_auteur, $bddext_type_pass;
		
		$this->nom = $this->email = $this->bio = $this->nom_site = $this->url_site = $this->pgp = $this->pass = $this->statut = '';		

		if (!$this->login) return false;

		// Si l'auteur existe dans la base, y recuperer les infos
		$query = "SELECT * FROM spip_auteurs WHERE login='".addslashes($this->login)."' AND source='bddext'";
		$result = spip_query($query);

		if ($row = spip_fetch_array($result)) {
			$this->nom = $row['nom'];
			$this->bio = $row['bio'];
			$this->email = $row['email'];
			$this->nom_site = $row['nom_site'];
			$this->url_site = $row['url_site'];
			$this->statut = $row['statut'];
			$this->pgp = $row['pgp'];
			return true;
		}

		
		// Lire les infos sur l'auteur depuis la base externe
		$query = "SELECT * FROM ".$bddext_table;
		if ($bddext_table_jointure!="") {
			$query.=", $bddext_table_jointure";
			$query=AjouteClause($query,"$bddext_table.$bddext_champ_jointure=$bddext_table_jointure.$bddext_champ_jointure");
		}
		$query=AjouteClause($query,$bddext_champs['login_ext']."='".addslashes($this->login)."'");
				
		$result = @$bddext_link->query($query);

		if ($rows = $result->fetchRow(DB_FETCHMODE_ASSOC) ) {
			$this->nom="";
			if ($bddext_champs['prenom']!="") $this->nom= ucwords(strtolower($rows[$bddext_champs['prenom']]))." ";
			$this->nom .= strtoupper($rows[$bddext_champs['nom']]);
			if (!$this->bio) $this->bio = $rows[$bddext_champs['bio']];
			if (!$this->email) $this->email = $rows[$bddext_champs['email']];
			if (!$this->bio) $this->nom_site = $rows[$bddext_champs['nom_site']];
			if (!$this->bio) $this->url_site = $rows[$bddext_champs['url_site']];
			if (!$this->bio) $this->pgp = $rows[$bddext_champs['pgp']];
			
			if ($bddext_champs['statut']!="") {
				$this->statut="";
				foreach($bddext_auteur as $cle => $val) if ($rows[$bddext_champs['statut']]==$val) $this->statut="1comite";
				foreach($bddext_admin as $cle => $val) if ($rows[$bddext_champs['statut']]==$val) $this->statut="0minirezo";
			}
			else $this->statut="1comite";
			return true;
		}
		return false;
	}

	function activer() {
		
		$nom = addslashes($this->nom);
		$bio = addslashes($this->bio);
		$login = addslashes($this->login);
		$email = addslashes($this->email);
		$nom_site = addslashes($this->nom_site);
		$url_site = addslashes($this->url_site);		
		$pgp = addslashes($this->pgp);
		$statut=$this->statut;

		if ($statut=="") exit;

		// Si l'auteur n'existe pas, l'inserer avec le statut par defaut (defini a l'install)
		$query = "SELECT id_auteur FROM spip_auteurs WHERE login='$login'";
		$result = spip_query($query);
		if (spip_num_rows($result)) return false;

		$query = "INSERT IGNORE INTO spip_auteurs (source, nom, login, email, bio, nom_site, url_site, pgp, statut, pass) ".
			"VALUES ('bddext', '$nom', '$login', '$email', '$bio', '$nom_site', '$url_site', '$pgp', '$statut', '')";
		return spip_query($query);
	}
}

?>
